﻿function view_onOpen()
{
	options.defaultValue("computerDelay") = 800;
	view.caption = NIM
	ngButton.tooltip = NEW_BUTTON
	goButton.tooltip = PASS_BUTTON
	helpButton.tooltip = HELP_BUTTON
	helpLabel.innerText = HELP_TEXT
	newGame()
}


row0 = new Array(spot00,spot01,spot02,spot03,spot04,spot05,spot06)
row1 = new Array(spot10,spot11,spot12,spot13,spot14,spot15,spot16)
row2 = new Array(spot20,spot21,spot22,spot23,spot24,spot25,spot26)
row3 = new Array(spot30,spot31,spot32,spot33,spot34,spot35,spot36)
row4 = new Array(spot40,spot41,spot42,spot43,spot44,spot45,spot46)

spots = new Array(row0,row1,row2,row3,row4)
playersTurn = true



function removeSpot(spot_to_remove)
{
	spot_to_remove.value = false
	spot_to_remove.visible = false
	spot_to_remove.enabled = false
}

function reactivateSpot(spot_to_activate)
{
	spot_to_activate.value = true
	spot_to_activate.visible = true
	spot_to_activate.enabled = true
}

function piecesLeft()
{
	totalPieces = 0
	rowLengths = findRowLengths(spots)
	for(i=0;i<rowLengths.length;i++) totalPieces += rowLengths[i]
	return totalPieces
}

function displayHelp()
{
	helpDiv.visible = !helpDiv.Visible
}

function validateMove()
{
	currentRow = event.srcElement.name.charAt(4)
	for(i=0;i<spots.length;i++) {
		if( i != currentRow ) {
			for(j=0;j<spots[i].length;j++) {
				if(spots[i][j].enabled && !spots[i][j].value) spots[i][j].value = true
			}
		}
	}

	if(firstMove) {
		goButton.tooltip = GO_BUTTON
	}
}

function endTurn()
{
if(playersTurn) {
	spotsRemoved = 0
	if(firstMove) goButton.tooltip = GO_BUTTON
	for(i=0;i<spots.length;i++) {
		for(j=0;j<spots[i].length;j++) {
			if(spots[i][j].enabled && !spots[i][j].value) {
				removeSpot(spots[i][j])
				spotsRemoved++	
			}
		}
	}

	if(piecesLeft()==0) gameOver(true)
	else if(spotsRemoved>0 || firstMove) compMove()
	if(firstMove) firstMove = false
}
}

function newGame()
{
	firstMove = true
	playersTurn = true
	goButton.visible = true
	winDiv.visible = false
	//winLabel.visible = false
	for(i=0;i<spots.length;i++) {
		for(j=0;j<spots[i].length;j++) {
			removeSpot(spots[i][j])
		}
	}

	for(i=0;i<spots.length;i++) {
		numSpots = Math.ceil(Math.random()*spots[i].length)
		for(j=0;j<numSpots;j++) {
			reactivateSpot(spots[i][j])
		}
	}
	
	goButton.tooltip = PASS_BUTTON
}

function compMove() 
{
	playersTurn = false
	rowLengths = findRowLengths(spots)
	rowList = new Array(spots.length)
	for(i=0;i<spots.length;i++) rowList[i] = i
	rowList.sort(myArrayShuffler)
	chooseRow = rowList[0]
	numToRemove = 0
	
	nimsum = findNimSum(rowLengths)
	
	if(nimsum!=0) {
		for(i=0;i<spots.length;i++) {
			if(rowLengths[rowList[i]]>0) {
				newnimsum = nimsum ^ rowLengths[rowList[i]]
				if(newnimsum < rowLengths[rowList[i]]) {
					chooseRow = rowList[i]
					numToRemove = rowLengths[rowList[i]] - newnimsum
					break
				}
			}
		}
	}
	if(numToRemove==0) {
		for(i=0;i<spots.length;i++) {
			if(rowLengths[rowList[i]]!=0) {
				chooseRow = rowList[i]
				break
			}
		}
		numToRemove = Math.floor( Math.random()*rowLengths[chooseRow] + 1 )
	}
	selectPieces(chooseRow,numToRemove)
	setTimeout("removePieces(chooseRow,numToRemove);playersTurn=true;if(piecesLeft()==0) {gameOver(false)}",options.item("computerDelay"))
	
	
}

function gameOver(player) 
{
	if(player) winLabel.innerText = WINNING_MESSAGE
	else winLabel.innerText = LOSING_MESSAGE 
	winDiv.visible = true
	winLabel.visible = true
	goButton.visible = false
}


function removePieces(myRow,numPieces)
{
	for(i=spots[myRow].length-1;i>=0;i--) {
		if(spots[myRow][i].visible) {
			removeSpot(spots[myRow][i])
			if(numPieces==1) break
			else numPieces--
		}
	}
		
}

function selectPieces(myRow,numPieces)
{
	for(i=spots[myRow].length-1;i>=0;i--) {
		if(spots[myRow][i].visible) {
			spots[myRow][i].value = false
			if(numPieces==1) break
			else numPieces--
		}
	}
		
}

function findNimSum(currRowLengths)
{
	nimsum = currRowLengths[0]
	for(i=0;i<currRowLengths.length-1;i++) {
		nimsum = nimsum ^ currRowLengths[i+1]
	}

	return nimsum 
}

function findRowLengths(myArray)
{
	rl = new Array(myArray.length)
	for(i=0;i<myArray.length;i++) {
		rl[i] = 0
		for(j=0;j<myArray[i].length;j++) {
			if(myArray[i][j].enabled) rl[i]++
		}
	}
	
	return rl
}

function myArrayShuffler(a, b)
{
	return (Math.floor(2*Math.random()))
}

function shuffleArray(arrayToShuffle)
{
	shuffledArray = arrayToShuffle
	return shuffledArray.sort(myArrayShuffler)
}

